// Generated by CoffeeScript 1.4.0
var createObject, deleteObject, getObject, parsen, queryObjects, request, updateObject, utils,
  _this = this;

request = require('request');

parsen = require('../parsen');

utils = require('../utils/utils');

createObject = function(className, data, callback) {
  if (data == null) {
    data = {};
  }
  parsen.checkForKeys();
  return request({
    method: 'POST',
    uri: "https://api.parse.com/1/classes/" + className,
    headers: {
      "X-Parse-Application-Id": parsen.parseApplicationId,
      "X-Parse-REST-API-Key": parsen.parseRESTAPIKey,
      "Content-Type": "application/json"
    },
    body: JSON.stringify(data)
  }, function(error, response, body) {
    return callback(error, response, body);
  });
};

getObject = function(className, objectId, callback) {
  parsen.checkForKeys();
  return request({
    method: 'GET',
    uri: "https://api.parse.com/1/classes/" + className + "/" + objectId,
    headers: {
      "X-Parse-Application-Id": parsen.parseApplicationId,
      "X-Parse-REST-API-Key": parsen.parseRESTAPIKey,
      "Content-Type": "application/json"
    }
  }, function(error, response, body) {
    return callback(error, response, body);
  });
};

updateObject = function(className, objectId, data, callback) {
  parsen.checkForKeys();
  return request({
    method: 'PUT',
    uri: "https://api.parse.com/1/classes/" + className + "/" + objectId,
    headers: {
      "X-Parse-Application-Id": parsen.parseApplicationId,
      "X-Parse-REST-API-Key": parsen.parseRESTAPIKey,
      "Content-Type": "application/json"
    },
    body: JSON.stringify(data)
  }, function(error, response, body) {
    return callback(error, response, body);
  });
};

deleteObject = function(className, objectId, callback) {
  parsen.checkForKeys();
  return request({
    method: 'DELETE',
    uri: "https://api.parse.com/1/classes/" + className + "/" + objectId,
    headers: {
      "X-Parse-Application-Id": parsen.parseApplicationId,
      "X-Parse-REST-API-Key": parsen.parseRESTAPIKey,
      "Content-Type": "application/json"
    }
  }, function(error, response, body) {
    return callback(error, response, body);
  });
};

queryObjects = function(className, params, callback) {
  parsen.checkForKeys();
  return request({
    method: 'GET',
    uri: "https://api.parse.com/1/classes/" + className + "?" + (utils.serialize(params)),
    headers: {
      "X-Parse-Application-Id": parsen.parseApplicationId,
      "X-Parse-REST-API-Key": parsen.parseRESTAPIKey,
      "Content-Type": "application/json"
    }
  }, function(error, response, body) {
    return callback(error, response, body);
  });
};

module.exports.createObject = createObject;

module.exports.getObject = getObject;

module.exports.updateObject = updateObject;

module.exports.deleteObject = deleteObject;

module.exports.queryObjects = queryObjects;
